<?php
defined($security_key) or exit;

//------------------------------------------
// discounts
//------------------------------------------
//Connect to DB
$pdo = dbConnect($dbname);

//CONTENT FROM API (POST)
$post_content = json_decode($input,true);

//SoldTo is empty
if (empty($partner->soldto) || $partner->soldto == ''){$soldto_search = '%';} else {$soldto_search = '-%';}

//default whereclause
list($whereclause,$condition) = getWhereclause('',$permission,$partner,'');


//BUILD UP PARTNERHIERARCHY FROM USER
$partner_product = json_encode(array("salesid"=>$partner->salesid,"soldto"=>$partner->soldto), JSON_UNESCAPED_UNICODE);

$id = $post_content['id'] ?? ''; //check for rowID
$command = ($id == '')? 'insert' : 'update';  //IF rowID = empty then INSERT
if (isset($post_content['delete'])){$command = 'delete';} //change command to delete

//CREATE EMPTY STRINGS
$clause = '';
$clause_insert ='';
$input_insert = '';

//IMPLODE CATEGORIES AND PRODUCTS
$post_content['category_ids'] = isset($post_content['categories']) ? implode(',', $post_content['categories']) : '';
$post_content['product_ids'] = isset($post_content['products']) ? implode(',', $post_content['products']) : '';
//REMOVE categories and products from post_content
if (isset($post_content['categories'])) { unset($post_content['categories']);}
if (isset($post_content['products'])) { unset($post_content['products']);}

if ($command == 'update'){
}
if ($command == 'insert'){
    $post_content['accounthierarchy'] = $partner_product;
}

//CREAT NEW ARRAY AND MAP TO CLAUSE
if(isset($post_content) && $post_content!=''){   
    foreach ($post_content as $key => $var){
        if ($key == 'submit' || $key == 'rowID'){
            //do nothing
        }
        else {
            $criterias[$key] = $var;
            $clause .= ' , '.$key.' = ?';
            $clause_insert .= ' , '.$key.'';
            $input_insert .= ', ?'; // ? for each insert item
            $execute_input[]= $var; // Build array for input
        }
    }
}

//CLEAN UP INPUT
$clause = substr($clause, 2); //Clean clause - remove first comma
$clause_insert = substr($clause_insert, 2); //Clean clause - remove first comma
$input_insert = substr($input_insert, 1); //Clean clause - remove first comma

//QUERY AND VERIFY ALLOWED
if ($command == 'update' && isAllowed('discounts',$profile,$permission,'U') === 1){
    $sql = 'UPDATE discounts SET '.$clause.' WHERE id = ? '.$whereclause.'';
    $execute_input[] = $id;
    $stmt = $pdo->prepare($sql);
    $stmt->execute($execute_input);
} 
elseif ($command == 'insert' && isAllowed('discounts',$profile,$permission,'C') === 1){
    $sql = 'INSERT INTO discounts ('.$clause_insert.') VALUES ('.$input_insert.')';
    $stmt = $pdo->prepare($sql);
    $stmt->execute($execute_input);
}
elseif ($command == 'delete' && isAllowed('discounts',$profile,$permission,'D') === 1){
    $sql = 'DELETE FROM discounts WHERE id = ? '.$whereclause;
    $stmt = $pdo->prepare($sql);
    $stmt->execute([$id]); 

    //Add deletion to changelog
    changelog($dbname,'discounts',$id,'Delete','Delete',$username);
} else
{
    //do nothing
}


?>